﻿var TEXT_LABEL_TOP_TITLE = "Process Seldex Mat Album";
var TEXT_LABEL_CHOOSE_ALBUM = "Choose album:";
var TEXT_LABEL_CHOOSE_FOLDER = "Choose folder:";
var TEXT_LABEL_MAT_PAGE = "Mat Page";
var TEXT_LABEL_FLUST_MOUNT = "Digital Flush Mount";
var TEXT_LABEL_LEFT_PAGE = "Left Page";
var TEXT_LABEL_RIGHT_PAGE = "Right Page";
var TEXT_NOTICE_FOLDER_DEFAULT = '';
var TEXT_NOTICE_FILELIST_EMPTY ="Not found file in folder.Plz try again.";
var TEXT_NOTICE_CHOOSE_FOLDER = "Please choose a folder.";
var TEXT_NOTICE_EXTENSION_FILE = "PSD";
var TEXT_NOTICE_ALERT_PROCESSED = "You have files waiting to be processed.";
var devbackgroundColor = 'ffffff';
//Album name, Flush with length, Flush height length, Mat width length, Mat heigth length (mm), size of mattes(w - h (mm))
var albumName=[
["Panoramic",450,318,440,310, 350,482],
["Vertical",318,425,310,415,482,350],
["Landscape PJ",356,279,350,275,317,392],
["Photojournal",279,356,275,350,392,317],
["Landscape Slimline",315,240,305,230,272,347],
["Portrait Slimline",240,315,230,305,347,272],
["16 Inch Square",406,406,400,400,442,442],
["13 Inch Square",330,330,320,320,362,362],
["12 Inch Gallery and Twin",315,315,305,305,350,350],
["9 Inch Gallery and Twin",235,235,225,225,272,272]
];


processesFiles();

function removeAllNamedbyTLDONOTDELETEArtLayers(obj) {
	for( var i = obj.artLayers.length-1; 0 <= i; i--) {
		try {
			if (obj.artLayers[i].name == "Trim Line - DO NOT DELETE")
			{
			obj.artLayers[i].remove();
			}
		} 
		catch (e) {
		}
	}
	for( var i = obj.layerSets.length-1; 0 <= i; i--) {
		removeAllNamedbyTLDONOTDELETEArtLayers(obj.layerSets[i]);
	}
	obj.save();
}

function hasLayerMask() {
	var ref = new ActionReference();
    ref.putEnumerated(charIDToTypeID("Lyr "), charIDToTypeID("Ordn"), charIDToTypeID("Trgt"));
    var desc = executeActionGet(ref);
    return desc.hasKey(charIDToTypeID("UsrM"));
}

function convertMM(mmInput, res){
	var outPX = parseFloat(mmInput*res)/25.4;
	return outPX;
}

function selectBounds(doc, b, type, feather, antialias) {
  doc.selection.select([[ b[0], b[1] ],
                          [ b[2], b[1] ],
                          [ b[2], b[3] ],
                          [ b[0], b[3] ]],
                         type, feather, antialias);
};


function getColorAt(doc, x, y) {
  // make new 1 pixel selection
  x = Math.floor(x);
  y = Math.floor(y);

  selectBounds(doc, [x, y, x+1, y+1]);

  try {
    function findPV(h) {
      for (var i = 0; i <= 255; i++ ) {
        if (h[i]) { return i; }
      }
      return 0;
    }
    
    var pColour = new SolidColor();
    
    pColour.rgb.red   = findPV(doc.channels["Red"].histogram);
    pColour.rgb.green = findPV(doc.channels["Green"].histogram);
    pColour.rgb.blue  = findPV(doc.channels["Blue"].histogram);

  } finally {
    doc.activeHistoryState = doc.historyStates[doc.historyStates.length-2]
  }

  return pColour;
};


function SaveJPEG(saveFile, jpegQuality){
    jpgSaveOptions = new JPEGSaveOptions();
    jpgSaveOptions.embedColorProfile = true;
    jpgSaveOptions.formatOptions = FormatOptions.STANDARDBASELINE;
    jpgSaveOptions.matte = MatteType.NONE;
    jpgSaveOptions.quality = jpegQuality; //1-12
    activeDocument.saveAs(saveFile, jpgSaveOptions, true,Extension.LOWERCASE);
}
function processesFiles(){
    app.displayDialogs = DialogModes.NO;
    try{
        var dlg="dialog{text:'Script Interface',bounds:[100,100,470,290],"+
                            "panel0:Panel{bounds:[10,10,360,180] , text:'' ,properties:{borderStyle:'etched',su1PanelCoordinates:true},"+
                                "title:StaticText{bounds:[40,10,340,30] , text:'"+TEXT_LABEL_TOP_TITLE+"' ,properties:{scrolling:undefined,multiline:undefined}},"+   
                                "panel1:Panel{bounds:[10,40,335,155] , text:'' ,properties:{borderStyle:'etched',su1PanelCoordinates:true},"+      
                                    "lblChooseAlbum:StaticText{bounds:[10,13,100,30] , text:'"+TEXT_LABEL_CHOOSE_ALBUM+"' ,properties:{scrolling:undefined,multiline:undefined}},"+
                                    "ddlAlbumName:DropDownList{bounds:[100,10,310,30]},"+  
                                    "lblChooseFolder:StaticText{bounds:[10,43,100,30] , text:'"+TEXT_LABEL_CHOOSE_FOLDER+"' ,properties:{scrolling:undefined,multiline:undefined}},"+
                                    "txtUrlFolder:EditText{bounds:[100,40,250,64] , text:'' ,properties:{multiline:false,noecho:false,readonly:false}},"+
                                    "btnBrowse:Button{bounds:[255,39,310,65] , text:'Browse' },"+
                                    "btnProcess:Button{bounds:[10,75,162,100] , text:'Process' },"+
                                    "btnCancel:Button{bounds:[167,75,310,100] , text:'Cancel' },"+
                                "},"+                            
                            "}"+ 
                        "},";
       
        var win = new Window(dlg,"www.FundySOS.com");   
        if(version.substr(0,version.indexOf('.'))>9){
            win.panel0.title.graphics.font = ScriptUI.newFont("Arial","BOLD",20);
            g = win.graphics;
            var myBrush = g.newBrush(g.BrushType.SOLID_COLOR, [1.00, 1.00, 1.00, 1]);
            g.backgroundColor = myBrush;
            var myPen =g.newPen (g.PenType.SOLID_COLOR, [1.00, 0.00, 0.00, 1],lineWidth=1);
        }
		
		
        win.panel0.panel1.txtUrlFolder.enabled=false;
        for(var z in albumName){
            win.panel0.panel1.ddlAlbumName.add('item',albumName[z][0].toString());
        }
        win.panel0.panel1.ddlAlbumName.selection = 0;
        
        //on click button Cancel
        win.panel0.panel1.btnCancel.onClick = function(){
           this.parent.parent.parent.close(1);
        }
    
        //on click button Browse
        win.panel0.panel1.btnBrowse.onClick = function() {
            if(win.panel0.panel1.txtUrlFolder.text!=""){
                choosed_folder = win.panel0.panel1.txtUrlFolder.text;
            }else{
                choosed_folder = TEXT_NOTICE_FOLDER_DEFAULT;
            }
            inputFolder = Folder.selectDialog("Please select the folder with Files to process",choosed_folder);	
            if(inputFolder !=null){
                win.panel0.panel1.txtUrlFolder.text =  decodeURI(inputFolder.fsName);
            }
        }
    
        //on click button Proccesss
        win.panel0.panel1.btnProcess.onClick = function() {
		
			var fgColor = new SolidColor;
			fgColor.rgb.hexValue = devbackgroundColor;
			app.backgroundColor = fgColor;
		
            var startRulerUnits = preferences.rulerUnits;
            preferences.rulerUnits = Units.MM;
            if(win.panel0.panel1.txtUrlFolder.text != ""){
                var str = "\\."+TEXT_NOTICE_EXTENSION_FILE.toLowerCase()+"$"; //filetype
                var fileMask = new RegExp(str, "i");
                var fileList = inputFolder.getFiles(fileMask);
                if(fileList.toString() == ''){                    
                    alert(TEXT_NOTICE_FILELIST_EMPTY);
                }else{
                    var albumNameChoosed = win.panel0.panel1.ddlAlbumName.selection.index;
					var width_global = albumName[albumNameChoosed][5];
					var height_global = albumName[albumNameChoosed][6];
                    win.close ();
                    var linksOutput = win.panel0.panel1.txtUrlFolder.text;
                    var MatFolder = Folder(decodeURI(win.panel0.panel1.txtUrlFolder.text)+ "/Mat Data");
                    if(!MatFolder.exists) MatFolder.create();
                    var PrintFolder = Folder(decodeURI(win.panel0.panel1.txtUrlFolder.text)+ "/Print Files");
                    if(!PrintFolder.exists) PrintFolder.create();
                    var dataSave = new File(decodeURI(win.panel0.panel1.txtUrlFolder.text)+ "/Mat Data/data.dat");                    
                    for(var i=0; i<fileList.length; i++){
                        open(fileList[i]);   
						removeAllNamedbyTLDONOTDELETEArtLayers(app.activeDocument);		
                        if(i==0){
                            //chay chuong trinh mo file dau tien                            
                            openFirst();
                        }
                        if(i==fileList.length-1){
                            //chay chuong trinh mo file cuoi
                            openLast();
                        }
                    
                        if(i>0 && i<fileList.length-1){
                            //chay chuong trinh mo file giua
                            openMiddle();
                        }
                    
                        function openFirst(){
                            //alert("Mo file dau ne");
                            var dlgFirst="dialog{text:'Script Interface',bounds:[100,100,470,290],"+
                                                    "panel0:Panel{bounds:[10,10,360,180] , text:'' ,properties:{borderStyle:'etched',su1PanelCoordinates:true},"+
                                                        "title:StaticText{bounds:[40,10,340,30] , text:'"+TEXT_LABEL_TOP_TITLE+"' ,properties:{scrolling:undefined,multiline:undefined}},"+   
                                                        "panel1:Panel{bounds:[10,40,335,155] , text:'Please choose:' ,properties:{borderStyle:'etched',su1PanelCoordinates:true},"+  
                                                            "MatPage:RadioButton{bounds:[20,13,310,30] , text:'"+TEXT_LABEL_MAT_PAGE+"' },"+
                                                            "FlusTPage:RadioButton{bounds:[20,40,310,60] , text:'"+TEXT_LABEL_FLUST_MOUNT+"' },"+
                                                            "btnProcess:Button{bounds:[10,75,310,100] , text:'Process' },"+
                                                        "},"+                            
                                                    "}"+ 
                                                "},";
                            var winFirst = new Window(dlgFirst,"www.FundySOS.com");   
                            if(version.substr(0,version.indexOf('.'))>9){
                                winFirst.panel0.title.graphics.font = ScriptUI.newFont("Arial","BOLD",20);
                                g = win.graphics;
                                var myBrush = g.newBrush(g.BrushType.SOLID_COLOR, [1.00, 1.00, 1.00, 1]);
                                g.backgroundColor = myBrush;
                                var myPen =g.newPen (g.PenType.SOLID_COLOR, [1.00, 0.00, 0.00, 1],lineWidth=1);
                            }
                            winFirst.panel0.panel1.MatPage.value = 1;
                            
                            winFirst.panel0.panel1.btnProcess.onClick = function() {
                                winFirst.close ();
                                dataSave.remove();
								var new_width;
								var new_height;
								//lay du lieu ra
								if(winFirst.panel0.panel1.MatPage.value){								
									new_width = albumName[albumNameChoosed][3];
									new_height = albumName[albumNameChoosed][4];
								}else{
									new_width = albumName[albumNameChoosed][1];
									new_height = albumName[albumNameChoosed][2];
								}
							
								//resize
								
								/*app.activeDocument.selection.selectAll();
								var fBound = app.activeDocument.selection.bounds;
								fWidth = parseFloat(fBound[2]- fBound[0]);
								fHeight = parseFloat(fBound[3]- fBound[1]);
								
								if(albumNameChoosed==0 || albumNameChoosed==2|| albumNameChoosed==4){
									var per_width_f = parseFloat(new_width/fWidth);
									var test_new_height = parseInt(fHeight*per_width_f);
									if(test_new_height<=new_height){
										new_height = test_new_height;
									}else{
										var per_height_f = parseFloat(new_height/fHeight);
										new_width = parseInt(fWidth*per_height_f);
									}
								}
						
								if(albumNameChoosed==1|| albumNameChoosed==3|| albumNameChoosed==5){
									var per_height_f = parseFloat(new_height/fHeight);
									var test_new_width = parseInt(fWidth*per_height_f);
									if(test_new_width<=new_width){
										new_width=test_new_width;
									}else{
										var per_width_f = parseFloat(new_width/fWidth);
										new_height = parseInt(fHeight*per_width_f);
									}
								}*/
								
								var exWidth = new_width;
								var exHeight = new_height;
								
								var res = app.activeDocument.resolution;
								//app.activeDocument.resizeImage(new_width, new_height, res, ResampleMethod.BICUBICSHARPER);
								app.activeDocument.resizeCanvas(exWidth , exHeight, AnchorPosition.MIDDLECENTER);
								//ket thuc resize
								
								
								var stringWriteSave = "1|"+activeDocument.name.substring (0, activeDocument.name.lastIndexOf ('.'))+"_RIGHT_Single ";
								if(winFirst.panel0.panel1.MatPage.value){
									stringWriteSave += "mat";
								}else{
									stringWriteSave += "flust mount";
								}
								dataSave.open("w");
									
								var number_aperture = 0;
								for(var k_add=0; k_add<app.activeDocument.layers.length-1; k_add++){
									app.activeDocument.activeLayer = app.activeDocument.layers[k_add];
									//if(hasLayerMask()){  
										number_aperture ++;
									//}
								} 
								var write_ape = true;
								var isFistPage = true;
								var firstCol = 0;
								
								for(var k=0; k<app.activeDocument.layers.length-1; k++){
									app.activeDocument.activeLayer = app.activeDocument.layers[k];
									//if(hasLayerMask()){
										var stringWriteSaveNew = stringWriteSave;
										var layerBounds = activeDocument.activeLayer.bounds;
										if(winFirst.panel0.panel1.MatPage.value){
											stringWriteSaveNew += "|C2|"+ roundHalfNumber(parseFloat(height_global))+"|"+roundHalfNumber(parseFloat(width_global))+"|";
											
											if(albumNameChoosed==0){
												firstCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[0]))) + 40;
												secondCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[1]))) + 39;
											}else if (albumNameChoosed==1){
												firstCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[0]))) + 39;
												secondCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[1]))) + 40;
											}else{
												firstCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[0]))) + 40;
												secondCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[1]))) + 40;
											}											
											thirdCol = parseFloat(roundHalfNumber(parseFloat(new UnitValue(layerBounds[2]-layerBounds[0],'mm'))))-6;
											forthCol = parseFloat(roundHalfNumber(parseFloat(new UnitValue(layerBounds[3]-layerBounds[1],'mm'))))-6;
											
											if(write_ape && number_aperture>1){
												stringWriteSaveNew += (firstCol).toFixed(1) + "|" + (secondCol).toFixed(1) + "|" + (thirdCol).toFixed(1) + "|" + (forthCol).toFixed(1) + ";Aperture@RE~MC" + Math.round(number_aperture-1);
												write_ape = false;
											}else{
												stringWriteSaveNew += (firstCol).toFixed(1) + "|" + (secondCol).toFixed(1) + "|" + (thirdCol).toFixed(1) + "|" + (forthCol).toFixed(1) + ";Aperture@RE";
											}
										}
										dataSave.writeln(stringWriteSaveNew);                                        
									//}
								}    
								dataSave.close();
								app.backgroundColor = getColorAt(app.activeDocument, 1, 1);
								var fistFile = new File(decodeURI(linksOutput+"/Print Files/"+activeDocument.name.substring (0, activeDocument.name.lastIndexOf ('.')) +".jpg"));
								SaveJPEG(fistFile,11);
                            }
                            winFirst.center();
                            winFirst.show();
                        }
                    
                        function openMiddle(){
                            var dlgMiddle="dialog{text:'Script Interface',bounds:[100,100,470,320],"+
                                                        "panel0:Panel{bounds:[10,10,360,210] , text:'' ,properties:{borderStyle:'etched',su1PanelCoordinates:true},"+
                                                            "title:StaticText{bounds:[40,10,340,30] , text:'"+TEXT_LABEL_TOP_TITLE+"' ,properties:{scrolling:undefined,multiline:undefined}},"+   
                                                            "panel1:Panel{bounds:[10,40,335,185] , text:'Please choose:' ,properties:{borderStyle:'etched',su1PanelCoordinates:true},"+  
                                                            
                                                                "lblLeftPage:StaticText{bounds:[10,13,150,30] , text:'"+TEXT_LABEL_LEFT_PAGE+"' },"+
                                                                "MatPageLeft:RadioButton{bounds:[20,40,150,60] , text:'"+TEXT_LABEL_MAT_PAGE+"' },"+
                                                                "FlusTPageLeft:RadioButton{bounds:[20,70,150,90] , text:'"+TEXT_LABEL_FLUST_MOUNT+"' },"+
                                                                
                                                                "lblRightPage:StaticText{bounds:[160,13,310,30] , text:'"+TEXT_LABEL_RIGHT_PAGE+"' },"+
                                                                "MatPageRight:RadioButton{bounds:[170,40,310,60] , text:'"+TEXT_LABEL_MAT_PAGE+"' },"+
                                                                "FlusTPageRight:RadioButton{bounds:[170,70,310,90] , text:'"+TEXT_LABEL_FLUST_MOUNT+"' },"+
                                                                
                                                                "btnProcess:Button{bounds:[10,100,310,125] , text:'Process' },"+
                                                            "},"+                            
                                                        "}"+ 
                                                    "},";
                            var winMiddle = new Window(dlgMiddle,"www.FundySOS.com");   
                            if(version.substr(0,version.indexOf('.'))>9){
                                winMiddle.panel0.title.graphics.font = ScriptUI.newFont("Arial","BOLD",20);
                                g = win.graphics;
                                var myBrush = g.newBrush(g.BrushType.SOLID_COLOR, [1.00, 1.00, 1.00, 1]);
                                g.backgroundColor = myBrush;
                                var myPen =g.newPen (g.PenType.SOLID_COLOR, [1.00, 0.00, 0.00, 1],lineWidth=1);
                            }
                            winMiddle.panel0.panel1.MatPageLeft.value = 1;
                            winMiddle.panel0.panel1.MatPageRight.value = 1;
                            
                            winMiddle.panel0.panel1.btnProcess.onClick = function() {
                                winMiddle.close ();
                                dataSave.open("r");
                                var stringWriteSaveOldM = dataSave.read();
                                dataSave.close();
								
								//Lay du lieu cua file can xuat ra
								var resize_w;
                                var resize_h;
                                if(winMiddle.panel0.panel1.MatPageLeft.value){
                                    resize_w = albumName[albumNameChoosed][3];
                                    resize_h = albumName[albumNameChoosed][4];
                                }else{
                                    resize_w = albumName[albumNameChoosed][1];
                                    resize_h = albumName[albumNameChoosed][2];
                                } 
								
								//Resize
								var boundTop;
                                var boundLeft;
                                var boundRight;
                                var boundBottom;
                                boundTop = 0;
                                boundLeft = 0;
                                
								app.activeDocument.selection.selectAll();
                                var mBound = app.activeDocument.selection.bounds;
                                mWidth = mBound[2]- mBound[0];
                                mHeight = mBound[3]- mBound[1];
								
                                boundRight = Math.round (mWidth/2);
                                boundBottom = mHeight;
								
								
								var bounds_crop  = new Array(boundLeft,boundTop,boundRight,boundBottom);
                                app.activeDocument.crop(bounds_crop);
                                var per_width=1;
                                var per_height=1;                                     
						
                                /*if(albumNameChoosed==0|| albumNameChoosed==2|| albumNameChoosed==4){
                                    per_width = resize_w/boundRight;
                                    var test_resize_h = mHeight*per_width;
									if(test_resize_h<=resize_h){
										resize_h = test_resize_h;
									}else{
										per_height = resize_h/mHeight;
										resize_w = boundRight*per_height;
									}
                                }
                            
                                if(albumNameChoosed==1|| albumNameChoosed==3|| albumNameChoosed==5){
                                    per_height = resize_h/mHeight;
                                    var test_resize_w = boundRight*per_height;
									if(test_resize_w<=resize_w){
										resize_w = test_resize_w;
									}else{
										per_width = resize_w/boundRight;
										resize_h = mHeight*per_width;
									}
                                }*/
								
								var exWidth = resize_w;
								var exHeight = resize_h;
								var exWidthL = exWidth;
								app.backgroundColor = getColorAt(app.activeDocument, 1, 1);
								var res = app.activeDocument.resolution;
								//app.activeDocument.resizeImage(resize_w, resize_h, res, ResampleMethod.BICUBICSHARPER);
								app.activeDocument.resizeCanvas(exWidth , exHeight, AnchorPosition.MIDDLECENTER);
                                
								//Ket thuc resize
                                
                                var stringWriteSaveM = "1|"+activeDocument.name.substring (0, activeDocument.name.lastIndexOf ('.'))+"_LEFT_Single ";
                                if(winMiddle.panel0.panel1.MatPageLeft.value){
                                    stringWriteSaveM += "mat";
                                }else{
                                    stringWriteSaveM += "flust mount";
                                }
                                dataSave.open("w");
                                dataSave.writeln(stringWriteSaveOldM);                                  
                                
                                //duyet layer
								var number_aperture = 0;
								for(var k_add=0; k_add<app.activeDocument.layers.length-1; k_add++){
                                    app.activeDocument.activeLayer = app.activeDocument.layers[k_add];
                                    //if(hasLayerMask()){  
										var layerBoundsCheck = activeDocument.activeLayer.bounds;
										
										if(layerBoundsCheck[0] <= exWidth && (layerBoundsCheck[2]-layerBoundsCheck[0]>0)){
											number_aperture ++;
										}
                                    //}
                                } 
								
								var write_ape = true;
								var isFistPage = true;
								var firstCol = 0;							
                                for(var km=0; km<app.activeDocument.layers.length-1; km++){
                                    app.activeDocument.activeLayer = app.activeDocument.layers[km];
                                    //if(hasLayerMask()){
                                        var layerBounds = activeDocument.activeLayer.bounds;
                                        if(layerBounds[0] <= exWidth && (layerBounds[2]-layerBounds[0]>0)){
											var stringWriteSaveMNew = stringWriteSaveM;
											if(winMiddle.panel0.panel1.MatPageLeft.value){
											
												stringWriteSaveMNew += "|C2|"+roundHalfNumber(parseFloat(height_global))+"|"+ roundHalfNumber(parseFloat(width_global))+"|";
											
												if(albumNameChoosed==0){
													firstCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[0]))) + 40;
													secondCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[1]))) + 39;
												}else if (albumNameChoosed==1){
													firstCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[0]))) + 39;
													secondCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[1]))) + 40;
												}else{
													firstCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[0]))) + 40;
													secondCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[1]))) + 40;
												}
												
												thirdCol = parseFloat(roundHalfNumber(parseFloat(layerBounds[2]-layerBounds[0]))) - 6;
												forthCol = parseFloat(roundHalfNumber(parseFloat(layerBounds[3]-layerBounds[1]))) - 6;
											
												if(write_ape && number_aperture>1){
													stringWriteSaveMNew += firstCol.toFixed(1) + "|" + (secondCol).toFixed(1) + "|" + (thirdCol).toFixed(1) + "|" + (forthCol).toFixed(1) + ";Aperture@RE~MC"+Math.round(number_aperture-1);
													write_ape = false;
												}else{
													stringWriteSaveMNew += firstCol.toFixed(1) + "|" + (secondCol).toFixed(1) + "|" + (thirdCol).toFixed(1) + "|" + (forthCol).toFixed(1) + ";Aperture@RE";
												}
											}
											dataSave.writeln(stringWriteSaveMNew);          
										}
                                    //}
                                } 
                                
                                var middleFileLeft = new File(decodeURI(linksOutput+"/Print Files/"+activeDocument.name.substring (0, activeDocument.name.lastIndexOf ('.')) +"_Left.jpg"));
                                SaveJPEG(middleFileLeft,11);
								
								//Quay lai trang thai ban dau
                                var baseState = app.activeDocument.historyStates.length - 4;
                                app.activeDocument.activeHistoryState = app.activeDocument.historyStates[baseState];
								
								//Lay du lieu
								if(winMiddle.panel0.panel1.MatPageRight.value){
                                    resize_w = albumName[albumNameChoosed][3];
                                    resize_h = albumName[albumNameChoosed][4];
                                }else{
                                    resize_w = albumName[albumNameChoosed][1];
                                    resize_h = albumName[albumNameChoosed][2];
                                }
								
								//Crop va resize
                                boundTop = 0;
                                boundLeft = Math.round (mWidth/2);
                                boundRight = mWidth;
                                boundBottom = mHeight;
								
                                var bounds_crop_r  = new Array(new UnitValue(boundLeft,'mm'),new UnitValue(boundTop,'mm'),new UnitValue(boundRight,'mm'),new UnitValue(boundBottom,'mm'));
								app.activeDocument.crop(bounds_crop_r);
								
								/*if(albumNameChoosed==0|| albumNameChoosed==2|| albumNameChoosed==4){
                                    per_width = resize_w/(boundRight/2);
                                    var test_resize_h = mHeight*per_width;
									if(test_resize_h<=resize_h){
										resize_h = test_resize_h;
									}else{
										per_height = resize_h/mHeight;
										resize_w = (boundRight/2)*per_height;
									}
                                }
                            
                                if(albumNameChoosed==1|| albumNameChoosed==3|| albumNameChoosed==5){
                                    per_height = resize_h/mHeight;
                                    var test_resize_w = (boundRight/2)*per_height;
									if(test_resize_w<=resize_w){
										resize_w = test_resize_w;
									}else{
										per_width = resize_w/(boundRight/2);
										resize_h = mHeight*per_width;
									}
                                }*/
								
								exWidth = resize_w;
								exHeight = resize_h;
                                
								var res = app.activeDocument.resolution;
								//app.activeDocument.resizeImage(resize_w, resize_h, res, ResampleMethod.BICUBICSHARPER);
								app.activeDocument.resizeCanvas(exWidth , exHeight, AnchorPosition.MIDDLECENTER);
								
								
                                var stringWriteSaveMR = "1|"+activeDocument.name.substring (0, activeDocument.name.lastIndexOf ('.'))+"_RIGHT_Single ";
                                if(winMiddle.panel0.panel1.MatPageRight.value){
                                    stringWriteSaveMR += "mat";
                                }else{
                                    stringWriteSaveMR += "flust mount";
                                }
                                
                                //duyet layer
								number_aperture = 0;
								for(var km_add=0; km_add<app.activeDocument.layers.length-1; km_add++){
                                    app.activeDocument.activeLayer = app.activeDocument.layers[km_add];
                                    //if(hasLayerMask()){  
										var layerBoundsRCheck = activeDocument.activeLayer.bounds;
                                        if(layerBoundsRCheck[0] > 0 || layerBoundsRCheck[2] > 0){
                                            number_aperture ++;
                                        }
                                    //}
                                } 
								
								write_ape = true;
								var isFistPage = true;
								var firstCol = 0;							
								dataSave.writeln('');  
								
                                for(var km2=0; km2<app.activeDocument.layers.length-1; km2++){
                                    app.activeDocument.activeLayer = app.activeDocument.layers[km2];                                    
                                    //if(hasLayerMask()){
                                        var layerBoundsR = activeDocument.activeLayer.bounds;										
                                        if(layerBoundsR[0] > 0 || layerBoundsR[2] > 0){
                                            var stringWriteSaveMRNew = stringWriteSaveMR;
                                            for(var ds=0; ds<layerBoundsR.length; ds++){
                                                var str = layerBoundsR[ds].toString();
                                                if(str.search("-") >=0){
                                                    layerBoundsR[ds] =0;
                                                }
                                            }
                                            if(layerBoundsR[0]==0){
                                                var wlayer = parseFloat(layerBoundsR[2]);                                                
                                            }else{
                                                var wlayer = parseFloat(layerBoundsR[2])-parseFloat(layerBoundsR[0]);
                                            }
                                            var hlayer = parseFloat(layerBoundsR[3])-parseFloat(layerBoundsR[1]);
											if(winMiddle.panel0.panel1.MatPageRight.value){
												stringWriteSaveMRNew += "|C2|"+ roundHalfNumber(parseFloat(height_global))+"|"+ roundHalfNumber(parseFloat(width_global))+"|";
											
												if(albumNameChoosed==0){													
													firstCol = parseFloat(roundHalfNumberNew(parseFloat(layerBoundsR[0]))) + 40;
													secondCol = parseFloat(roundHalfNumberNew(parseFloat(layerBoundsR[1]))) + 39;			
												}else if (albumNameChoosed==1){
													firstCol = parseFloat(roundHalfNumberNew(parseFloat(layerBoundsR[0]))) + 39;
													secondCol = parseFloat(roundHalfNumberNew(parseFloat(layerBoundsR[1]))) + 40;	
													
												}else{
													firstCol = parseFloat(roundHalfNumberNew(parseFloat(layerBoundsR[0]))) + 40;
													secondCol = parseFloat(roundHalfNumberNew(parseFloat(layerBoundsR[1]))) + 40;			
												}
												
												thirdCol = parseFloat(roundHalfNumber(wlayer))-6;
												forthCol = parseFloat(roundHalfNumber(hlayer))-6;
											
												if(write_ape && number_aperture>1){
													stringWriteSaveMRNew += (firstCol).toFixed(1) + "|" + (secondCol).toFixed(1) + "|"+ (thirdCol).toFixed(1) + "|" + (forthCol).toFixed(1) + ";Aperture@RE~MC"+Math.round(number_aperture-1);
													write_ape = false;
												}else{
													stringWriteSaveMRNew += (firstCol).toFixed(1) + "|" + (secondCol).toFixed(1) + "|" + (thirdCol).toFixed(1) + "|" + (forthCol).toFixed(1) + ";Aperture@RE";
												}
											}                                            
                                            dataSave.writeln(stringWriteSaveMRNew);     
                                        }
                                    //}
                                }   
                                dataSave.close();
								
                                var middleFileRight = new File(decodeURI(linksOutput+"/Print Files/"+activeDocument.name.substring (0, activeDocument.name.lastIndexOf ('.')) +"_Right.jpg"));                           
                                SaveJPEG(middleFileRight,11);
                            }
                            winMiddle.center();
                            winMiddle.show();
                        }
						
						function roundHalfNumber(inNumber) {

						   try {
								var intPartNumber = (Math.floor(inNumber)).toFixed(1);
								var floatNumberPart = inNumber - intPartNumber;
								var outNumber = inNumber;
								if (floatNumberPart < 0.5) {
									outNumber = intPartNumber;
								} else {
									//if (floatNumberPart >= 0.75) {
									outNumber = parseFloat(intPartNumber) + 1;
									//} else {
									//	outNumber = parseFloat(intPartNumber) + 0.5;
									//}							
								}
								return outNumber;
						   }catch(e) {
							 //alert(e);
							 return 0;
						   }							
						}
						
						function roundHalfNumberNew(inNumber) {

						   try {
								var intPartNumber = (Math.floor(inNumber)).toFixed(1);
								var floatNumberPart = inNumber - intPartNumber;
								var outNumber = inNumber;
								if (floatNumberPart < 0.5) {
									outNumber = intPartNumber;
								} else {
									if (floatNumberPart >= 0.75) {
										outNumber = parseFloat(intPartNumber) + 1;
									} else {
										outNumber = parseFloat(intPartNumber) + 0.5;
									}							
								}
								return outNumber;
						   }catch(e) {
							 //alert(e);
							 return 0;
						   }							
						}
                        
                        function openLast(){    
                            var dlgLast="dialog{text:'Script Interface',bounds:[100,100,470,290],"+
                                                    "panel0:Panel{bounds:[10,10,360,180] , text:'' ,properties:{borderStyle:'etched',su1PanelCoordinates:true},"+
                                                        "title:StaticText{bounds:[40,10,340,30] , text:'"+TEXT_LABEL_TOP_TITLE+"' ,properties:{scrolling:undefined,multiline:undefined}},"+   
                                                        "panel1:Panel{bounds:[10,40,335,155] , text:'Please choose:' ,properties:{borderStyle:'etched',su1PanelCoordinates:true},"+      
                                                            "MatPage:RadioButton{bounds:[20,13,310,30] , text:'"+TEXT_LABEL_MAT_PAGE+"' },"+
                                                            "FlusTPage:RadioButton{bounds:[20,40,310,60] , text:'"+TEXT_LABEL_FLUST_MOUNT+"' },"+
                                                            "btnProcess:Button{bounds:[10,75,310,100] , text:'Process' },"+
                                                        "},"+                            
                                                    "}"+ 
                                                "},";
                            var winLast = new Window(dlgLast,"www.FundySOS.com");   
                            if(version.substr(0,version.indexOf('.'))>9){
                                winLast.panel0.title.graphics.font = ScriptUI.newFont("Arial","BOLD",20);
                                g = win.graphics;
                                var myBrush = g.newBrush(g.BrushType.SOLID_COLOR, [1.00, 1.00, 1.00, 1]);
                                g.backgroundColor = myBrush;
                                var myPen =g.newPen (g.PenType.SOLID_COLOR, [1.00, 0.00, 0.00, 1],lineWidth=1);
                            }
                            winLast.panel0.panel1.MatPage.value = 1;
                            
                            winLast.panel0.panel1.btnProcess.onClick = function() {
                                winLast.close ();
								var new_width;
                                var new_height;
								//lay du lieu ra
                                if(winLast.panel0.panel1.MatPage.value){
                                    new_width = albumName[albumNameChoosed][3];
                                    new_height = albumName[albumNameChoosed][4];
                                }else{
                                    new_width = albumName[albumNameChoosed][1];
                                    new_height = albumName[albumNameChoosed][2];
                                } 
								
								//resize
								/* app.activeDocument.selection.selectAll();
                                var lBound = app.activeDocument.selection.bounds;
                                lWidth = lBound[2]-lBound[0];
                                lHeight = lBound[3]-lBound[1];
								if(albumNameChoosed==0|| albumNameChoosed==2|| albumNameChoosed==4){
                                    var per_width_l = new_width/lWidth;
                                    var test_new_height = lHeight*per_width_l;
									if(test_new_height<=new_height){
										new_height = test_new_height;
									}else{
										var per_height_l = new_height/lHeight;
										new_width = lWidth*per_height_l;
									}
                                }
                            
                                if(albumNameChoosed==1|| albumNameChoosed==3|| albumNameChoosed==5){
                                    var per_height_l = new_height/lHeight;
                                    var test_new_width = lWidth*per_height_l;
									if(test_new_width<=new_width){
										new_width = test_new_width;
									}else{
										var per_width_l = new_width/lWidth;
										new_height = lHeight*per_width_l;
									}
                                }  */          

								exWidth = new_width;
								exHeight = new_height;	
								
                                app.backgroundColor = getColorAt(app.activeDocument, 1, 1);
								var res = app.activeDocument.resolution;
								//app.activeDocument.resizeImage(new_width, new_height, res, ResampleMethod.BICUBICSHARPER);
								app.activeDocument.resizeCanvas(exWidth , exHeight, AnchorPosition.MIDDLECENTER);
								//ket thuc resize
								
                                dataSave.open("r");
                                var stringWriteSaveOld = dataSave.read();
                                dataSave.close();
                               
                                var stringWriteSave = "1|"+activeDocument.name.substring (0, activeDocument.name.lastIndexOf ('.'))+"_LEFT_Single ";
                                if(winLast.panel0.panel1.MatPage.value){
                                    stringWriteSave += "mat";
                                }else{
                                    stringWriteSave += "flust mount";
                                }
								var number_aperture = 0;
								for(var km_add=0; km_add<app.activeDocument.layers.length-1; km_add++){
                                    app.activeDocument.activeLayer = app.activeDocument.layers[km_add];
                                    //if(hasLayerMask()){  
										number_aperture ++;
                                    //}
                                } 
								var write_ape = true;
								var isFistPage = true;
								var firstCol = 0;
								
                                dataSave.open("w");
                                dataSave.writeln(stringWriteSaveOld);           
                                for(var k=0; k<app.activeDocument.layers.length-1; k++){
                                    app.activeDocument.activeLayer = app.activeDocument.layers[k];
                                    //if(hasLayerMask()){
                                        var stringWriteSaveNew = stringWriteSave;
                                        var layerBounds = activeDocument.activeLayer.bounds;
										if(winLast.panel0.panel1.MatPage.value){
											stringWriteSaveNew += "|C2|"+ roundHalfNumber(parseFloat(height_global))+"|"+ roundHalfNumber(parseFloat(width_global))+"|";
											
											if(albumNameChoosed==0){													
												firstCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[0]))) + 40;
												secondCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[1])))+ 39;				
											}else if (albumNameChoosed==1){
												firstCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[0]))) + 39;
												secondCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[1])))+ 40;													
											}else{
												firstCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[0]))) + 40;
												secondCol = parseFloat(roundHalfNumberNew(parseFloat(layerBounds[1])))+ 40;		
											}											
											
											thirdCol = parseFloat(roundHalfNumber(parseFloat(layerBounds[2]-layerBounds[0])))- 6;
											forthCol = parseFloat(roundHalfNumber(parseFloat(layerBounds[3]-layerBounds[1])))- 6;	
																			
											if(write_ape && number_aperture>1){
												stringWriteSaveNew += (firstCol).toFixed(1) + "|" + (secondCol).toFixed(1) + "|" + (thirdCol).toFixed(1) + "|" + (forthCol).toFixed(1) + ";Aperture@RE~MC"+Math.round(number_aperture-1);
												write_ape = false;
											}else{
												stringWriteSaveNew += (firstCol).toFixed(1) + "|" + (secondCol).toFixed(1) + "|" + (thirdCol).toFixed(1) + "|" + (forthCol).toFixed(1) +";Aperture@RE";
											}
										}                                        
                                        dataSave.writeln(stringWriteSaveNew);                                        
                                    //}
                                }    
                                dataSave.close();
                                
                                var lastFile = new File(decodeURI(linksOutput+"/Print Files/"+activeDocument.name.substring (0, activeDocument.name.lastIndexOf ('.')) +".jpg"));
                                SaveJPEG(lastFile,11);
                            }
                            winLast.center();
                            winLast.show();
                        }
                        app.activeDocument.close(SaveOptions.DONOTSAVECHANGES);
                    }     
                    preferences.rulerUnits = startRulerUnits;
                }
            }else{
                alert(TEXT_NOTICE_CHOOSE_FOLDER);
            }
        }   
    
        win.center();
        win.show();
    }catch(e){       
    }
}